/*! Cortona3D Solo Universal Viewer bundle - training, Copyright (c) 2015-2024 Paragraphics Ltd. (http://www.cortona3d.com/) */
define((function(){return function(t){var e={};function i(s){if(e[s])return e[s].exports;var n=e[s]={i:s,l:!1,exports:{}};return t[s].call(n.exports,n,n.exports,i),n.l=!0,n.exports}return i.m=t,i.c=e,i.d=function(t,e,s){i.o(t,e)||Object.defineProperty(t,e,{enumerable:!0,get:s})},i.r=function(t){"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},i.t=function(t,e){if(1&e&&(t=i(t)),8&e)return t;if(4&e&&"object"==typeof t&&t&&t.__esModule)return t;var s=Object.create(null);if(i.r(s),Object.defineProperty(s,"default",{enumerable:!0,value:t}),2&e&&"string"!=typeof t)for(var n in t)i.d(s,n,function(e){return t[e]}.bind(null,n));return s},i.n=function(t){var e=t&&t.__esModule?function(){return t.default}:function(){return t};return i.d(e,"a",e),e},i.o=function(t,e){return Object.prototype.hasOwnProperty.call(t,e)},i.p="",i(i.s=3)}([function(module,exports,__webpack_require__){var __WEBPACK_AMD_DEFINE_RESULT__;__WEBPACK_AMD_DEFINE_RESULT__=function(require,exports,module){var rtsAPI=__webpack_require__(1),PRODUCTION;function dispatch(t,e){t[e]&&t[e].apply(t,Array.prototype.slice.call(arguments,2))}function node_value(t){return t||null}var _CONSTRUCTORS={scenario:"Scenario",variable:"Variable",operation:"Operation","seq-group":"Sequence","and-group":"SequenceAND","or-group":"SequenceOR","next-step":"Next",jump:"Jump",step:"Step",alert:"Alert",activity:"Activity",animation:"Animation",viewpoint:"Viewpoint",viewpoints:"Viewpoints",objects:"Parts",object:"Part",metainfo:"Meta",assignment:"Assignment",assignments:"Assignments",question:"Question",list:"List","request-variable":"RequestVariable"};function parse_node(node,name){var result=null;return node&&eval("result = new "+_CONSTRUCTORS[name]+"().loadFromNode(node);"),result}var _scenario=null;function Scenario(){this.id=null,this.steps={},this.variables={},this.parts=null,this.viewpoints=null,this.description="",this.comments=null,this.url="",this.vrmlUrl="",this.odfUrl="",this.odfId=null,this.version=null,this.username=null,this.initialStep=null,this.history=new History(this),this.activeStep=null,this.active=!1,this.score_accumulator=0,this.steps_count=0,this.successStatus="unknown",this.startTime=0,_scenario=this}function Scenario_getVar(t){var e="_"+t,i="_$"+t;if(!(e in this.variables)&&!(i in this.variables))throw new Error(404,"Variable '"+t+"' not defined.");return i in this.variables?this.variables[i].valueOf():this.variables[e].valueOf()}function Scenario_setVar(t,e){var i="_"+t,s="_$"+t;if(!(i in this.variables)&&!(s in this.variables))throw new Error(404,"Variable '"+t+"' not defined.");s in this.variables?this.variables[s].setValue(e):this.variables[i].setValue(e)}function Scenario_getSessionTime(){return Math.round(((new Date).valueOf()-this.startTime.valueOf())/10)/100}function Scenario_getSuccessStatus(){return this.successStatus}function Scenario_getScaledScore(){return 0==this.steps_count?1:this.score_accumulator/this.steps_count}function Scenario_initialize(){for(var t in this.active=!1,this.activeStep=null,this.score_accumulator=0,this.steps_count=0,this.successStatus="unknown",this.variables)this.variables[t].initialize()}function Scenario_loadFromNode(t){return this.description=t.$text("description"),this.comments=t.$text("comment"),this.vrmlUrl=t.$text("vrml-file"),this.odfUrl=t.$text("document-file"),this.id=t.$attr("id"),this.odfId=t.$attr("document-ref")||(this.odfUrl?null:this.id),this.version=t.$text("version"),this.initialStep=null,this.activeStep=null,this.initialize(),this.variables={},t.$("variables/variable").forEach((function(t){this.variables[t.$attr("name")]=parse_node(t,"variable")}),this),this.viewpoints=parse_node(t.$("viewpoints/viewpoint"),"viewpoints"),this.parts=parse_node(t.$("objects/object"),"objects"),this.steps={},t.$("steps/step").forEach((function(t,e){var i=parse_node(t,"step");this.steps[i.id]=i,0===e&&(this.initialStep=i)}),this),this}function Scenario_isLoaded(){return this.initialStep}function Scenario_isActive(){return this.active}function Scenario_start(){this.isLoaded()&&!this.active&&(this.startTime=new Date,this.initialize(),this.active=!0,this.successStatus="passed",this.history.initialize(),this.history.push(new HistoryStartScenario(this.variables)),dispatch(this,"on_scenario_start"),this.startStep(this.initialStep))}function Scenario_cancel(){this.active&&(this.active=!1,this.successStatus="failed",this.history.push(new HistoryFinishScenario(this.getSuccessStatus(),this.getScaledScore(),this.variables)),dispatch(this,"on_scenario_cancel"),this.initialize())}function Scenario_fail(){this.active&&(this.successStatus="failed",this.startStep())}function Scenario_startStep(t){if(this.active)if(this.activeStep&&(this.steps_count+=Math.abs(this.activeStep.weight),this.score_accumulator+=this.activeStep.getScaledScore()*this.activeStep.weight,dispatch(this,"on_step_finish",this.activeStep),this.history.steps.length&&(this.history.steps[this.history.steps.length-1].score=this.activeStep.getScaledScore())),this.activeStep=t,this.activeStep)this.activeStep.initialize(),dispatch(this,"on_step_start",this.activeStep),this.history.push(new HistoryStep(this.activeStep,this.variables)),this.processStep();else{this.active=!1;var e=0;try{e=this.getVar("cmi.scaled_passing_score")}catch(t){}this.getScaledScore()<e&&(this.successStatus="failed"),this.history.push(new HistoryFinishScenario(this.getSuccessStatus(),this.getScaledScore(),this.variables)),dispatch(this,"on_scenario_finish")}}function Scenario_processStep(){if(this.active&&this.activeStep){var t=this.activeStep.getExpectedOperations();t.length>0?dispatch(this,"on_expected_operations",t):this.startStep(this.activeStep.nextStep())}}function Scenario_processInput(oInput){if(this.active&&this.activeStep){var leo=this.activeStep.getExpectedOperations(),aOperations=[],bError=!!oInput;this.history.push(new HistoryInput(oInput));for(var i=0;i<leo.length;i++)if(leo[i].checkPattern(oInput)){if(oInput&&oInput.constructor==Variable&&(this.variables[oInput.name].value=oInput.value,bError=!1),!oInput||oInput.constructor!=String&&oInput.constructor!=Array){aOperations.push(leo[i]),this.history.push(new HistoryOperation(leo[i],this.variables)),leo[i].assignments&&leo[i].assignments.array.forEach((function(t){t.proceed()}));try{eval(leo[i].script)}catch(t){alert("ERROR: "+t.message+"\r\n\n"+leo[i].script)}bError=!1}!oInput||oInput.constructor!=String&&oInput.constructor!=Array||(bError=!1)}!leo.length&&oInput&&oInput.constructor!=Activity&&(bError=!1),aOperations.length>0?dispatch(this,"on_operations",aOperations,oInput):bError&&(this.activeStep.errors++,this.history.push(new HistoryFault(this.activeStep.errorLimits-this.activeStep.errors+1)),dispatch(this,"on_step_input_failed",this.activeStep,oInput))}}function Variable(){this.cmi="",this.name="",this.value=null,this.type="string",this.defaultValue=null,this.description="",this.comments=null,this.items=[]}function Variable_initialize(){this.cmi&&rtsAPI.isStub()&&rtsAPI.getAPI().SetValue(this.cmi,this.defaultValue,!0),this.value=this.defaultValue}function Variable_valueOf(){var t="";if(this.cmi){var e=rtsAPI.get(this.cmi);if(void 0!==e)if("enumeration"!=this.type)this.value=e;else{for(var i=0;i<this.items.length&&this.items[i]!=e;i++);i<this.items.length&&(this.value=i)}}switch(this.type){case"enumeration":this.items&&this.value>=0&&this.value<this.items.length&&(t=this.items[this.value].valueOf());break;default:t=this.value.valueOf()}return t}function Variable_defaultValueOf(){var t="";switch(this.type){case"enumeration":this.items&&this.value>=0&&this.value<this.items.length&&(t=this.items[this.defaultValue].valueOf());break;default:t=this.defaultValue.valueOf()}return t}function Variable_equal(t){return t.name==this.name}function Variable_setValue(value){switch(this.cmi&&("enumeration"==this.type?this.items&&value>=0&&value<this.items.length&&rtsAPI.set(this.cmi,this.items[value]):rtsAPI.set(this.cmi,value)),this.type){case"enumeration":case"numeric":case"number":this.value=new Number(value);break;case"boolean":this.value=new Boolean(Number(value));break;case"string":if(/^\{[\s\S\n]*\}$/.test(value)){try{this.value=new String(eval("(function()"+value+")();"))}catch(t){alert("EVALUATE EXCEPTION: "+t.message),this.value=""}break}default:this.value=new String(value)}}function Variable_getValueString(){var t;if(this.cmi){var e=rtsAPI.get(this.cmi);if(void 0!==e)if("enumeration"!=this.type)this.value=e;else{for(var i=0;i<this.items.length&&this.items[i]!=e;i++);i<this.items.length&&(this.value=i)}}switch(this.type){case"numeric":case"number":case"boolean":case"enumeration":t=this.value.toString();break;case"string":t='"'+this.value.replace(/\\/g,"\\\\").replace(/"/g,'\\"')+'"';break;default:t=this.value}return t}function Variable_loadFromNode(t){return t?(this.name=t.$attr("name"),this.trueName=this.name.replace(/^_\$?/,""),this.hidden=0===this.name.indexOf("_$"),this.type=t.$attr("type"),this.setValue(t.$attr("initial-value")),this.defaultValue=this.value,this.description=t.$text("description"),this.comments=t.$text("comment"),this.items=parse_node(t.$("list/list-item"),"list"),0===this.name.indexOf("_cmi.")&&(this.cmi=this.name.substring(1)),this):null}function Variable_toString(){return'Variable { name "'+this.name+'" value "'+this.valueOf()+'" }'}function Variable_toXML(){return'<variable name="'+this.name+'">'+xmltext(this.value)+"</variable>\r\n"}function Step(){this.id=null,this.odfId=null,this.sequence=null,this.nextstep=null,this.description="",this.comments=null,this.viewpoints=null,this.errorLimits=3,this.weight=1,this.errors=0,this.completed=!1}function Step_getRemainingAttempts(){var t=-1;return this.errorLimits>=0&&(t=this.errorLimits-this.errors+1),t}function Step_getSuccessStatus(){return this.completed?this.errors<this.errorLimits?"passed":"failed":"unknown"}function Step_getScaledScore(){var t=1;return this.errorLimits>0?t=Math.max(0,1-this.errors/this.errorLimits):0===this.errorLimits&&(t=0===this.errors?1:0),t}function Step_initialize(){this.succesStatus="unknown",this.errors=0,this.completed=!1,this.sequence&&this.sequence.initialize()}function Step_getExpectedOperations(){var t=[];return this.sequence&&(t=this.sequence.getExpectedOperations()),t}function Step_nextStep(){var t=null;return this.nextstep&&(t=this.nextstep.proceed()),t}function Step_loadFromNode(t){if(t){this.id=t.$attr("id"),this.odfId=t.$attr("document-ref")||this.id,this.errorLimits=Number(t.$attr("faults-count")),this.weight=Number(t.$attr("weight")),this.description=t.$text("description"),this.comments=t.$text("comment");var e=t.$("action/*");return e.length>0&&(this.sequence=parse_node(e[0],e[0]["@name"])),this.nextstep=parse_node(t.$("next-step/jump"),"next-step"),this.viewpoints=parse_node(t.$("viewpoints/viewpoint"),"viewpoints"),this}return null}function Step_getOperations(){var t=[];return this.sequence&&(t=t.concat(this.sequence.getOperations())),t}function Sequence(){this.children=[],this.current=0,this.description="",this.comments=null}function Sequence_initialize(){this.current=0,this.children.forEach((function(t){t.initialize()}))}function Sequence_isCompleted(){for(;this.current<this.children.length&&this.children[this.current].isCompleted();)this.current++;return this.children.length==this.current}function Sequence_isActive(){if(this.isCompleted())return!0;for(var t=0,e=0;e<=this.current;e++)this.children[e].isActive()&&t++;return t>0}function Sequence_getExpectedOperations(){var t=[];return this.isCompleted()||(t=this.children[this.current].getExpectedOperations()),t}function Sequence_loadFromNode(t){return t?(this.description=t.$text("description"),this.comments=t.$text("comment"),this.children=t.$("*").filter((function(t){var e=" "+t["@name"]+" ";return" seq-group and-group or-group operation ".indexOf(e)>=0})).map((function(t){return parse_node(t,t["@name"])})),this):null}function Sequence_getOperations(){for(var t=[],e=0;e<this.children.length;e++)t=t.concat(this.children[e].getOperations());return t}function Sequence_isInteractivity(){return!0}function SequenceAND(){this.children=[],this.description="",this.comments=null}function SequenceAND_initialize(){this.children.forEach((function(t){t.initialize()}))}function SequenceAND_isCompleted(){for(var t=0,e=0;e<this.children.length;e++)this.children[e].isCompleted()&&t++;return t==this.children.length}function SequenceAND_isActive(){if(this.isCompleted())return!0;for(var t=0,e=0;e<this.children.length;e++)this.children[e].isActive()&&t++;return t>0}function SequenceAND_getExpectedOperations(){var t=[];if(!this.isCompleted())for(var e=0;e<this.children.length;e++)this.children[e].isCompleted()||(t=t.concat(this.children[e].getExpectedOperations()));return t}function SequenceOR(){this.children=[],this.description="",this.comments=null}function SequenceOR_initialize(){this.children.forEach((function(t){t.initialize()}))}function SequenceOR_isCompleted(){for(var t=0,e=0;e<this.children.length;e++)this.children[e].isCompleted()&&t++;return t>0}function SequenceOR_getExpectedOperations(){var t=[];if(!this.isCompleted()){for(var e=null,i=0;i<this.children.length;i++)if(t=t.concat(this.children[i].getExpectedOperations()),this.children[i].isActive()){e=this.children[i];break}e&&(t=e.getExpectedOperations())}return t}function SequenceOR_getOperations(){var t=[];return this.children.length>0&&(t=t.concat(this.children[0].getOperations())),t}function Operation(){this.id=null,this.activity=null,this.animation=null,this.message=null,this.description="",this.comments=null,this.odfId=null,this.assignments=null,this.script="",this.completed=!1}function Operation_toXML(){var t='<operation  ref="'+this.id+'" document-ref="'+(this.odfId?this.odfId:"")+'">';if(t+="<description>"+this.description+"</description>",this.activity){var e=this.activity.getTemplate();e&&(t+=e.toXML())}if(this.message&&(t+="<message>"+this.message+"</message>"),this.assignments)for(var i in this.assignments.assoc)t+=this.assignments.assoc[i].toXML();return t+="</operation>\r\n"}function Operation_initialize(){this.completed=!1,this.activity&&this.activity.initialize()}function Operation_isCompleted(){return this.completed}function Operation_isActive(){return!(!this.activity||this.activity.constructor!=Activity)&&(!this.activity.selected.length||this.activity.selected.some((function(t){return t})))}function Operation_checkPattern(t){if(this.activity){if(this.activity.equal(t))return this.completed=t.constructor!=String&&t.constructor!=Array,this}else if(this.activity==t)return this.completed=!0,this;return null}function Operation_getExpectedOperations(){var t=[];return this.isCompleted()||t.push(this),t}function Operation_loadFromNode(t){if(t){this.description=t.$text("description"),this.comments=t.$text("comment"),this.animation=parse_node(t.$("animation/animstep"),"animation"),this.animation&&(this.animation.initialFraction=Number(t.$("animation")[0].$attr("initial-fraction")||0)),this.message=t.$text("message");var e=t.$("alert")[0],i=t.$("request-variable")[0],s=t.$("activity")[0];e?this.activity=parse_node(e,"alert"):i?this.activity=parse_node(i,"request-variable"):s&&(this.activity=parse_node(s,"activity")),this.script=t.$text("script")||"",this.id=t.$attr("id"),this.odfId=t.$attr("document-ref")||this.id,this.assignments=parse_node(t.$("assignments/assignment"),"assignments");try{this.activity.setOperation(this)}catch(t){}return this}return null}function Operation_getOperations(){var t=[];return t.push(this),t}function Operation_isInteractivity(){var t=this.activity;if(t){if(t.constructor==Activity){if(t.objects.length>0)return!0;if(t.lists.length>0&&t.lists[0].items.length>0)return!0}if(t.constructor==RequestVariable)return!0}return!1}function Animation(){this.substeps=[],this.initialFraction=0}function Animation_loadFromNode(t){return this.substeps=t.map((function(t){return t.$text()})),t.length>0?this:null}function Alert(){this._type="Alert",this.type="note",this.odfId=null,this.description=""}function Alert_toXML(){var t='<alert document-ref="'+(this.odfId?this.odfId:"")+'">';return t+="<description>"+this.description+"</description>",t+="</alert>\r\n"}function Alert_setOperation(t){this.odfId=t.odfId,this.description=t.description}function Alert_equal(t){return t===this}function Alert_loadFromNode(t){return t?(this.type=t.$attr("type")||"note",this):null}function Alert_isActive(){return!0}function Alert_initialize(){}function Alert_getTemplate(){return this}function RequestVariable(){this._type="RequestVariable",this.prompt="",this.name="",this.value=null}function RequestVariable_isActive(){return!0}function RequestVariable_initialize(){}function RequestVariable_equal(t){var e=!1;return t&&t.constructor==Variable&&t.name==this.name&&(e=!0),e}function RequestVariable_loadFromNode(t){return t?(this.prompt=t.$text(),this.name=t.$attr("variable-name"),this.value=t.$attr("default-value"),this):null}function RequestVariable_getTemplate(){var t=new Variable;return t.name=this.name,t.value=arguments.length>0?arguments[0][this.name]:this.value,t}function Activity(){this._type="Activity",this.description="",this.comments=null,this.objects=[],this.lists=[],this.selected=[],this.selectionType=0}function Activity_initialize(){this.selected.length=this.objects.length;for(var t=0;t<this.selected.length;t++)this.selected[t]=!1}function Activity_isActive(){function t(t){return t}return 0===this.selected.length||(0===this.selectionType?this.selected.every(t):this.selected.some(t))}function Activity_equal(t){var e,i=!1;if(t)switch(t.constructor){case Template:var s=this.getTemplate().objects;for(i=s.length==t.objects.length,e=0;e<s.length&&i;e++)i=i&&s[e]==t.objects[e];for(e=0;e<this.lists.length&&i;e++)i=i&&t.para[this.lists[e].text]==this.lists[e].items[0];break;case String:for(e=0;e<this.objects.length;e++)if(this.objects[e]==t){this.selected[e]=!0,i=!0;break}break;case Array:for(e=0;e<this.objects.length;e++){var n=this.objects[e];if(t.some((function(t){return n==t}))){this.selected[e]=!0,i=!0;break}}}else i=0===this.objects.length&&0===this.lists.length;return i}function Activity_loadFromNode(t){if(t){var e=(t.$attr("multiple-object-selection-type")||"and").toLowerCase();return this.description=t.$text("description"),this.comments=t.$text("comment"),this.selectionType="or"==e?1:0,this.objects=t.$("object-ref").map((function(t){return t.$text()})),this.lists=t.$("question").map((function(t){return parse_node(t,"question")})),this.objects.length+this.lists.length===0?null:this}return null}function Activity_getTemplate(){var t,e={};for(t=0;t<this.lists.length;t++)e[this.lists[t].text]=this.lists[t].items[0];var i=[];if(!this.isActive()&&this.objects.length>0)0===this.selectionType?i=this.objects:i.push(this.objects[0]);else for(t=0;t<this.objects.length;t++)this.selected[t]&&i.push(this.objects[t]);return new Template(i,e)}function Template(t,e){this.objects=t,this.para=e}function Template_toXML(){for(var t="<template>",e=0;e<this.objects.length;e++)t+="<object>"+xmltext(this.objects[e])+"</object>";for(var i in this.para)t+='<para name="'+i+'">'+xmltext(this.para[i])+"</para>";return t+="</template>\r\n"}function Template_equal(t){var e,i=t.objects.length==this.objects.length;for(e=0;e<this.objects.length&&i;e++)i=i&&this.objects[e]==t.objects[e];for(e=0;e<t.lists.length&&i;e++)i=i&&this.para[t.lists[e].text]==t.lists[e].items[0];return i}function Template_toString(){for(var t="Template { ",e=0;e<this.objects.length;e++)t+='object "'+this.objects[e]+'" ';for(var i in this.para)t+='option { name "'+i+'" value "'+this.para[i]+'" } ';return t+="}"}function Question(){this.text="",this.items=[]}function Question_loadFromNode(t){if(t){this.text=t.$attr("text"),this.items=parse_node(t.$("list/list-item"),"list")||[];var e=Number(t.$attr("right-answer"))||0;if(e>0&&e<this.items.length){var i=this.items[0];this.items[0]=this.items[e],this.items[e]=i}return this}return null}function List(){}function List_loadFromNode(t){return t.map((function(t){return t.$text()}))}function Next(){this.description="",this.comments=null,this.children=[]}function Next_loadFromNode(t){return this.children=t.map((function(t){return parse_node(t,"jump")})),t.length>0?this:null}function Next_proceed(){var step=null,var_syntax="";for(var key in _scenario.variables)_scenario.variables[key].cmi||(var_syntax+="var "+key+" = "+_scenario.variables[key].getValueString()+";");for(var i=0;i<this.children.length;i++){var result=!0;if(this.children[i].condition){result=!1;var cond=this.children[i].condition.replace(/_(cmi\.[\w\d\.]+)/g,'rtsAPI.get("$1")'),syntax=var_syntax+"return ("+cond+");";try{result=eval("(function(){"+syntax+"})();")}catch(t){alert("CONDITION WARNING: "+t.message+"\r\n\n"+syntax)}}if(result){var next_step_id=this.children[i].step_id;next_step_id&&void 0!==_scenario.steps[next_step_id]&&(step=_scenario.steps[next_step_id]);break}}return step}function Jump(){this.condition=null,this.step_id=null}function Jump_loadFromNode(t){return t?(this.step_id=t.$attr("step"),this.condition=t.$text("condition"),this):null}function Viewpoint(){this.substep=null,this.value=null,this.description="",this.comments=null}function Viewpoint_loadFromNode(t){return t?(this.substep=t.$text("animstep"),this.value=t.$text("viewpoint-value"),this.value&&(this.value=this.value.replace(/^\s+|\s+$/,"").split(" "),13==this.value.length?this.value[12]=0:this.value=null),this.description=t.$text("description"),this.comments=t.$text("comment"),this):null}function Viewpoints(){this._CHILD_NODE_NAME="viewpoint",this._KEY_NAME="description",this.array=[],this.assoc={}}function _AbstractHolder_loadFromNode(t){this.array=[],this.assoc={};for(var e=0;e<t.length;e++){var i=parse_node(t[e],this._CHILD_NODE_NAME);this.array.push(i),this.assoc[i[this._KEY_NAME]]=i}return this}function _AbstractHolder_getAssocArray(){return result}function Part(){this.vrmlref=null,this.name=null,this.metainfo=null}function Part_loadFromNode(t){return t?(this.vrmlref=t.$attr("id"),this.name=t.$attr("name"),this.metainfo=(new Metainfo).loadFromNode(t.$("metainfo")),this):null}function Parts(){this._CHILD_NODE_NAME="object",this._KEY_NAME="vrmlref",this.array=[],this.assoc={}}function Meta(){this.name="",this.type="string",this.value=""}function Meta_loadFromNode(t){return t?(this.name=t.$attr("name"),this.type=(t.$attr("type")||"").toLowerCase()||"string",this.value=t.$text(),"viewpoint-value"==this.type&&(this.value=this.value.replace(/^\s+/,"").replace(/\s+$/,"").split(" ")),this):null}function Meta_toString(){return this.value}function Metainfo(){this._CHILD_NODE_NAME="metainfo",this._KEY_NAME="name",this.array=[],this.assoc={}}function Assignments(){this._CHILD_NODE_NAME="assignment",this._KEY_NAME="name",this.array=[],this.assoc={}}function Assignment(){this.name="",this.expression=""}function Assignment_toXML(){return'<assignment name="'+this.name+'">'+xmltext(this.expression)+"</assignment>\r\n"}function Assignment_loadFromNode(t){return t?(this.name=t.$attr("variable-name"),this.expression=t.$attr("new-value"),this):null}function Assignment_proceed(){_scenario.variables[this.name].setValue(this.expression)}function History(t){this.XMLNS="http://services.parallelgraphics.com/vm/mmr/vm-training-history-xml/all",this.scenario=t,this.steps=[],this.start=null,this.finish=null}function History_toXML(){function t(t,e){return" "+t+'="'+e+'"'}var e="<scenario-history "+t("xmlns",this.XMLNS)+t("ref",this.scenario.id)+(this.scenario.odfId?t("document-ref",this.scenario.odfId):"")+(this.scenario.version?t("version",this.scenario.version):"")+(this.scenario.username?t("user",this.scenario.username):"")+">\r\n";e+="<description>"+xmltext(this.scenario.description)+"</description>\r\n",e+='<scenario-file src="'+this.scenario.vrmlUrl.replace(/.wrl/,".training.xml")+'" />\r\n',e+=this.start.toXML(),e+="<steps>\r\n";for(var i=0;i<this.steps.length;e+=this.steps[i++].toXML());return e+="</steps>\r\n",e+=this.finish.toXML(),e+="</scenario-history>\r\n"}function History_initialize(){this.steps=[]}function History_isEmpty(){return!this.steps.length}function History_drop(){for(var t=[],e=0;e<this.steps.length;e++)t=t.concat(this.steps[e].getSubsteps());return t}function History_pop(){return this.steps.pop()}function History_push(t){switch(t.constructor){case HistoryStartScenario:this.start=t;break;case HistoryFinishScenario:this.finish=t;break;case HistoryStep:this.steps.push(t);break;case HistoryOperation:case HistoryInput:case HistoryFault:this.steps.length>0&&this.steps[this.steps.length-1].history.push(t)}}function HistoryStep(t,e){for(var i in this.step=t,this.history=[],this.variables_set={},this.score=0,this.weight=t.weight,this.faultsLimit=t.errorLimits,e)this.variables_set[i]=e[i].valueOf()}function HistoryStep_toXML(){var t='<step ref="'+this.step.id+'" document-ref="'+(this.step.odfId?this.step.odfId:"")+'" score="'+this.score+'" weight="'+this.weight+'" faultsLimit="'+this.faultsLimit+'">';for(var e in t+="<description>"+xmltext(this.step.description)+"</description>",t+="<variables-set>",this.variables_set)t+='<variable name="'+e+'">'+xmltext(this.variables_set[e])+"</variable>";t+="</variables-set>",t+="<history>";for(var i=0;i<this.history.length;t+=this.history[i++].toXML());return t+="</history>",t+="</step>\r\n"}function HistoryStep_getSubsteps(){for(var t=[],e=0;e<this.history.length;e++)if(this.history[e].constructor==HistoryOperation){var i=this.history[e].value.animation;i&&(t=t.concat(i.substeps))}return t}function HistoryStep_isNotInteractive(){for(var t=!0,e=0;e<this.history.length&&t;e++)this.history[e].constructor==HistoryInput&&(t=t&&(!this.history[e].value||this.history[e].value.constructor==Alert));return t}function HistoryInput(t){this.value=t,this.timestamp=new Date,this.location=[];try{this.location=api.get_viewpoint_data()}catch(t){}}function HistoryInput_toXML(){var t='<history-item timestamp="'+this.timestamp.toUTCString()+'" type="input">';return 13==this.location.length&&(t+="<viewpoint-value>"+this.location.join(" ")+"</viewpoint-value>"),this.value?this.value.constructor==String&&(t+="<select><object>"+xmltext(this.value)+"</object></select>"):t+="<null/>",this.value.constructor==Array?t+="<select><chain>"+xmltext(this.value.toString())+"</chain></select>":t+=this.value.toXML(),t+="</history-item>\r\n"}function HistoryOperation(t,e){for(var i in this.value=t,this.timestamp=new Date,this.variables_set={},e)this.variables_set[i]=e[i].valueOf()}function HistoryOperation_toXML(){var t='<history-item timestamp="'+this.timestamp.toUTCString()+'" type="operation">';for(var e in t+="<variables-set>",this.variables_set)t+='<variable name="'+e+'">'+xmltext(this.variables_set[e])+"</variable>";return t+="</variables-set>",t+=this.value.toXML(this.variables_set),t+="</history-item>\r\n"}function HistoryFault(t){this.value=t,this.timestamp=new Date}function HistoryFault_toXML(){var t='<history-item timestamp="'+this.timestamp.toUTCString()+'" type="fault">';return t+="<fault>"+this.value+"</fault>",t+="</history-item>\r\n"}function HistoryStartScenario(t){for(var e in this.timestamp=new Date,this.variables_set={},t)this.variables_set[e]=t[e].valueOf()}function HistoryStartScenario_toXML(){var t='<start timestamp="'+this.timestamp.toUTCString()+'">';for(var e in t+="<variables-set>",this.variables_set)t+='<variable name="'+e+'">'+xmltext(this.variables_set[e])+"</variable>";return t+="</variables-set>",t+="</start>\r\n"}function HistoryFinishScenario(t,e,i){for(var s in this.status=t,this.score=e,this.timestamp=new Date,this.variables_set={},i)this.variables_set[s]=i[s].valueOf()}function HistoryFinishScenario_toXML(){var t='<finish timestamp="'+this.timestamp.toUTCString()+'">';for(var e in t+="<variables-set>",this.variables_set)t+='<variable name="'+e+'">'+xmltext(this.variables_set[e])+"</variable>";return t+="</variables-set>",t+="<status>"+this.status+"</status>",t+="<score>"+Math.floor(100*this.score)/100+"</score>",t+="</finish>\r\n"}function xmltext(t){var e=new ActiveXObject("Microsoft.XMLDOM"),i=e.createDocumentFragment();return i.appendChild(e.createTextNode(t)),i.xml}Scenario.prototype.initialize=Scenario_initialize,Scenario.prototype.loadFromNode=Scenario_loadFromNode,Scenario.prototype.isLoaded=Scenario_isLoaded,Scenario.prototype.isActive=Scenario_isActive,Scenario.prototype.start=Scenario_start,Scenario.prototype.cancel=Scenario_cancel,Scenario.prototype.fail=Scenario_fail,Scenario.prototype.getScaledScore=Scenario_getScaledScore,Scenario.prototype.getSuccessStatus=Scenario_getSuccessStatus,Scenario.prototype.getSessionTime=Scenario_getSessionTime,Scenario.prototype.getVar=Scenario_getVar,Scenario.prototype.setVar=Scenario_setVar,Scenario.prototype.startStep=Scenario_startStep,Scenario.prototype.processStep=Scenario_processStep,Scenario.prototype.processInput=Scenario_processInput,Variable.prototype.equal=Variable_equal,Variable.prototype.defaultValueOf=Variable_defaultValueOf,Variable.prototype.valueOf=Variable_valueOf,Variable.prototype.setValue=Variable_setValue,Variable.prototype.getValueString=Variable_getValueString,Variable.prototype.loadFromNode=Variable_loadFromNode,Variable.prototype.initialize=Variable_initialize,Variable.prototype.toString=Variable_toString,Variable.prototype.toXML=Variable_toXML,Step.prototype.initialize=Step_initialize,Step.prototype.getExpectedOperations=Step_getExpectedOperations,Step.prototype.getOperations=Step_getOperations,Step.prototype.nextStep=Step_nextStep,Step.prototype.loadFromNode=Step_loadFromNode,Step.prototype.getScaledScore=Step_getScaledScore,Step.prototype.getSuccessStatus=Step_getSuccessStatus,Step.prototype.getRemainingAttempts=Step_getRemainingAttempts,Sequence.prototype.initialize=Sequence_initialize,Sequence.prototype.isCompleted=Sequence_isCompleted,Sequence.prototype.isActive=Sequence_isActive,Sequence.prototype.getExpectedOperations=Sequence_getExpectedOperations,Sequence.prototype.loadFromNode=Sequence_loadFromNode,Sequence.prototype.getOperations=Sequence_getOperations,Sequence.prototype.isInteractivity=Sequence_isInteractivity,SequenceAND.prototype.initialize=SequenceAND_initialize,SequenceAND.prototype.isCompleted=SequenceAND_isCompleted,SequenceAND.prototype.isActive=SequenceAND_isActive,SequenceAND.prototype.getExpectedOperations=SequenceAND_getExpectedOperations,SequenceAND.prototype.loadFromNode=Sequence_loadFromNode,SequenceAND.prototype.getOperations=Sequence_getOperations,SequenceAND.prototype.isInteractivity=Sequence_isInteractivity,SequenceOR.prototype.initialize=SequenceOR_initialize,SequenceOR.prototype.isCompleted=SequenceOR_isCompleted,SequenceOR.prototype.isActive=SequenceAND_isActive,SequenceOR.prototype.getExpectedOperations=SequenceOR_getExpectedOperations,SequenceOR.prototype.loadFromNode=Sequence_loadFromNode,SequenceOR.prototype.getOperations=SequenceOR_getOperations,SequenceOR.prototype.isInteractivity=Sequence_isInteractivity,Operation.prototype.initialize=Operation_initialize,Operation.prototype.isCompleted=Operation_isCompleted,Operation.prototype.isActive=Operation_isActive,Operation.prototype.checkPattern=Operation_checkPattern,Operation.prototype.getExpectedOperations=Operation_getExpectedOperations,Operation.prototype.loadFromNode=Operation_loadFromNode,Operation.prototype.getOperations=Operation_getOperations,Operation.prototype.isInteractivity=Operation_isInteractivity,Operation.prototype.toXML=Operation_toXML,Animation.prototype.loadFromNode=Animation_loadFromNode,Alert.prototype.setOperation=Alert_setOperation,Alert.prototype.equal=Alert_equal,Alert.prototype.loadFromNode=Alert_loadFromNode,Alert.prototype.isActive=Alert_isActive,Alert.prototype.initialize=Alert_initialize,Alert.prototype.getTemplate=Alert_getTemplate,Alert.prototype.toXML=Alert_toXML,RequestVariable.prototype.equal=RequestVariable_equal,RequestVariable.prototype.loadFromNode=RequestVariable_loadFromNode,RequestVariable.prototype.isActive=RequestVariable_isActive,RequestVariable.prototype.initialize=RequestVariable_initialize,RequestVariable.prototype.getTemplate=RequestVariable_getTemplate,Activity.prototype.equal=Activity_equal,Activity.prototype.loadFromNode=Activity_loadFromNode,Activity.prototype.isActive=Activity_isActive,Activity.prototype.initialize=Activity_initialize,Activity.prototype.getTemplate=Activity_getTemplate,Template.prototype.equal=Template_equal,Template.prototype.toString=Template_toString,Template.prototype.toXML=Template_toXML,Question.prototype.loadFromNode=Question_loadFromNode,List.prototype.loadFromNode=List_loadFromNode,Next.prototype.loadFromNode=Next_loadFromNode,Next.prototype.proceed=Next_proceed,Jump.prototype.loadFromNode=Jump_loadFromNode,Viewpoint.prototype.loadFromNode=Viewpoint_loadFromNode,Viewpoints.prototype.loadFromNode=_AbstractHolder_loadFromNode,Part.prototype.loadFromNode=Part_loadFromNode,Parts.prototype.loadFromNode=_AbstractHolder_loadFromNode,Meta.prototype.loadFromNode=Meta_loadFromNode,Meta.prototype.toString=Meta_toString,Meta.prototype.valueOf=Meta_toString,Metainfo.prototype.loadFromNode=_AbstractHolder_loadFromNode,Assignments.prototype.loadFromNode=_AbstractHolder_loadFromNode,Assignment.prototype.loadFromNode=Assignment_loadFromNode,Assignment.prototype.proceed=Assignment_proceed,Assignment.prototype.toXML=Assignment_toXML,History.prototype.initialize=History_initialize,History.prototype.isEmpty=History_isEmpty,History.prototype.drop=History_drop,History.prototype.pop=History_pop,History.prototype.push=History_push,History.prototype.toXML=History_toXML,HistoryStep.prototype.getSubsteps=HistoryStep_getSubsteps,HistoryStep.prototype.isNotInteractive=HistoryStep_isNotInteractive,HistoryStep.prototype.toXML=HistoryStep_toXML,HistoryInput.prototype.toXML=HistoryInput_toXML,HistoryOperation.prototype.toXML=HistoryOperation_toXML,HistoryFault.prototype.toXML=HistoryFault_toXML,HistoryStartScenario.prototype.toXML=HistoryStartScenario_toXML,HistoryFinishScenario.prototype.toXML=HistoryFinishScenario_toXML,module.exports={Scenario:Scenario,Variable:Variable}}.call(exports,__webpack_require__,exports,module),void 0===__WEBPACK_AMD_DEFINE_RESULT__||(module.exports=__WEBPACK_AMD_DEFINE_RESULT__)},function(t,e,i){var s;void 0===(s=function(t,e,s){var n=new function(){var t=null,e=!1,s=!1,n=function(e){console.error("ERROR: "+e+" - "+t.GetErrorString(e),": "+t.GetDiagnostic(e))};this.constructor.prototype.isStub=function(){return!!this.getAPI().isSoloStub||s},this.constructor.prototype.isTerminated=function(){return e},this.constructor.prototype.getAPI=function(){var e=function(t){for(var e=0;null==t.API_1484_11&&null!=t.parent&&t.parent!=t;){if(++e>500)return console.error("Error finding API -- too deeply nested."),null;t=t.parent}return t.API_1484_11};return t||((t=e(window))||null==window.opener||void 0===window.opener||(t=e(window.opener)),t||(console.error("Unable to locate the LMS's API Implementation. Communication with the LMS will not occur."),console.log("Switch to LMS's API stub."),s=!0,t=i(4))),t},this.constructor.prototype.initialize=function(){var t=!1,e=this.getAPI();return e&&((t="true"==e.Initialize(""))||n(e.GetLastError())),t},this.constructor.prototype.terminate=function(){var t=!1,i=this.getAPI();return i&&(e||(e=!0,(t="true"==i.Terminate(""))||n(i.GetLastError()))),t},this.constructor.prototype.get=function(t){if(!e){var i=this.getAPI();if(i){var s=i.GetValue(t),r=i.GetLastError();if("0"==r)return s;n(r)}}},this.constructor.prototype.set=function(t,i){var s=!1;if(!e){var r=this.getAPI();r&&((s="true"==r.SetValue(t,i))||n(r.GetLastError()))}return s},this.constructor.prototype.commit=function(){var t=!1;if(!e){var i=this.getAPI();i&&((t="true"==i.Commit())||n(i.GetLastError()))}return t},this.constructor.prototype.startLO=function(t){return this.getAPI().startLO(t)},this.constructor.prototype.setValueForItemById=function(t,e,i){return"true"==this.getAPI().SetValueForItemById(t,e,i)},this.constructor.prototype.getValueForItemById=function(t,e){return this.getAPI().GetValueForItemById(t,e)}};s.exports=n}.call(e,i,e,t))||(t.exports=s)},,function(t,e,i){var s;void 0===(s=function(t,e,s){var n=window.Cortona3DSolo,r=(n.app.procedure.interactivity,n.app.modelInfo.companionFile.replace(/\.interactivity\.xml$/i,".training.xml"));if(n.training)s.exports=Promise.resolve(n.training);else{var o,a,c,l=i(0).Scenario,u=i(0).Variable,p=new l,h=i(5),_=-1,m=0,d=[],f={sco:h,interactivity:{json:{},getObjectName:function(t){return n.training.interactivity.json.$("scenario/objects/object").reduce((function(e,i){return i.$attr("id")===t?i.$attr("name"):e}),"")},getObjectViewpoint:function(t){return n.training.interactivity.json.$("scenario/objects/object").reduce((function(e,i){if(i.$attr("id")===t){var s=i.$("metainfo").filter((function(t){return"$vp"===t.$attr("name")}))[0];if(s)return s.$text()}return e}),"")}},start:function(t){void 0===t&&(t=f.MODE_DEMO),_=+t,p.start()},cancel:function(){p.cancel(),_=-1},fail:function(){p.fail(),_=-1},resume:function(){p.active=!0},isDemo:function(){return _===f.MODE_DEMO},isStudy:function(){return _===f.MODE_STUDY},isExam:function(){return _===f.MODE_EXAM},setViewpointValue:function(t){var e=t.split(" ");if("function"==typeof n.app.setCameraPosition)n.app.setCameraPosition(e.slice(3,6),e.slice(6,10),-1,e.slice(0,3),!0);else{e.slice(0,3).join(" ");var i="Viewpoint { jump FALSE position "+e.slice(3,6).join(" ")+" orientation "+e.slice(6,10).join(" ")+"}";o&&n.app.removeObjects(o),o=n.app.createObjectsFromString(i)[0],n.app.addObjects(o),n.once("core.didDrawAnimationFrame",(function(){n.app.activeViewpoint=o}))}},processInput:p.processInput.bind(p),processStep:p.processStep.bind(p),startStep:p.startStep.bind(p),getSuccessStatus:p.getSuccessStatus.bind(p),getScaledScore:p.getScaledScore.bind(p),getSessionTime:p.getSessionTime.bind(p),isActive:p.isActive.bind(p),createVariable:function(t,e){var i=new u;return i.name=t,i.type=e,i},restoreVariables:function(t){for(var e in t){var i=p.variables[e];p.variables[e].setValue("enumeration"===i.type?i.items.indexOf(t[e]):t[e])}}};Object.defineProperty(f,"MODE_DEMO",{value:0}),Object.defineProperty(f,"MODE_STUDY",{value:1}),Object.defineProperty(f,"MODE_EXAM",{value:2}),Object.defineProperty(f,"MODE_PLAY",{value:1}),Object.defineProperty(f,"MODE_STOP",{value:0}),Object.defineProperty(f,"MODE_PAUSE",{value:2}),Object.defineProperty(f,"activeStep",{get:function(){return p.activeStep},enumerable:!0,configurable:!0}),Object.defineProperty(f,"history",{get:function(){return p.history},enumerable:!0,configurable:!0}),Object.defineProperty(f,"variables",{get:function(){return p.variables},enumerable:!0,configurable:!0}),Object.defineProperty(f,"username",{get:function(){return p.username},set:function(t){p.username=t},enumerable:!0,configurable:!0}),Object.defineProperty(f,"scaledPassingScore",{get:function(){return p.scaledPassingScore},set:function(t){p.scaledPassingScore=t},enumerable:!0,configurable:!0}),Object.defineProperty(f,"mode",{get:function(){return+_},enumerable:!0,configurable:!0}),Object.defineProperty(f,"expected",{get:function(){return d},enumerable:!0,configurable:!0}),Object.defineProperty(f,"playMode",{get:function(){return+m},set:function(t){m!=t&&(m=t,n.dispatch("training.didChangePlayMode",t))},enumerable:!0,configurable:!0}),n.expand(p,{on_scenario_start:function(){d=[],n.dispatch("training.didStartScenario",_)},on_scenario_finish:function(){n.dispatch("training.didFinishScenario")},on_scenario_cancel:function(){d=[],n.dispatch("training.didCancelScenario")},on_step_start:function(t){n.dispatch("training.didStartScenarioStep",t)},on_step_finish:function(t){n.dispatch("training.didFinishScenarioStep",t)},on_expected_operations:function(t){d=t,n.dispatch("training.didChangeExpectedOperations",t)},on_operations:function(t,e){n.dispatch("training.didScenarioOperations",t,e)},on_step_input_failed:function(t,e){n.dispatch("training.didFailScenarioStepInput",t,e)}}),n.training=f,s.exports=(a=r,c=function(t){return n.app.util.createResourceURL(t)||n.app.util.toUrl(t,n.app.modelInfo.baseURL)}(a),n.app.util.loadResource(c,"text/xml").then((function(t){return n.app.util.revokeResourceURL(c),t.responseXML?Promise.resolve(n.app.util.xmlToJSON(t.responseXML)):Promise.reject(new Error(c+" empty content"))}))).then((function(t){return f.interactivity.json=t,p.loadFromNode(t.$("scenario")[0]),f}))}}.call(e,i,e,t))||(t.exports=s)},function(t,e,i){var s;void 0===(s=function(t,e,i){var s=new function(){var t=function(e){var i=e;if("object"==typeof e&&e instanceof Object)for(var s in i={},e)i[s]=t(e[s]);return i};function e(){var t=/(\d{4})-(\d{2})-(\d{2})T(\d{2}):(\d{2}):(\d{2})(.\d{1,2})(Z|[+-]\d{2}:\d{2}|[+-]\d{2})|(\d{4})-(\d{2})-(\d{2})T(\d{2}):(\d{2}):(\d{2})(.\d{1,2})|(\d{4})-(\d{2})-(\d{2})T(\d{2}):(\d{2}):(\d{2})|(\d{4})-(\d{2})-(\d{2})T(\d{2}):(\d{2})|(\d{4})-(\d{2})-(\d{2})T(\d{2})|(\d{4})-(\d{2})-(\d{2})|(\d{4})-(\d{2})|(\d{4})/;return this.date=arguments.length&&arguments[0]instanceof Date?arguments[0]:new Date,this.constructor.prototype.toString=function(){var t=function(t){return t<10?"0"+t:t},e="";return e+=[this.date.getFullYear(),t(this.date.getMonth()+1),t(this.date.getDate())].join("-"),e+="T",e+=[t(this.date.getHours()),t(this.date.getMinutes()),t(this.date.getSeconds())+"."+t(Math.round(this.date.getMilliseconds()/10))].join(":")},this.constructor.prototype.check=function(e){var i=t.exec(e);return i&&i[0].length==e.length},this.constructor.prototype.parse=function(e){var i=t.exec(e);if(i&&i[0].length==e.length){var s=new Date(0),n=i[8],r=1;if(n){if(s.setUTCFullYear(i[r++]),r<i.length&&i[r]&&(s.setUTCMonth(i[r++]-1),r<i.length&&i[r]&&(s.setUTCDate(i[r++]),r<i.length&&i[r]&&(s.setUTCHours(i[r++]),r<i.length&&i[r]&&(s.setUTCMinutes(i[r++]),r<i.length&&i[r]&&(s.setUTCSeconds(i[r++]),r<i.length&&i[r]&&s.setUTCMilliseconds(1e3*i[r++])))))),"Z"!=n){var o="-"==n.charAt(0)?-1:1;n=(n=n.split(":")).length>1?o*(parseInt(n[1])+60*Math.abs(n[0])):o*Math.abs(n[0])*60,s.setUTCMinutes(s.getUTCMinutes()-n)}}else{for(r=9;!i[r];r++);s.setFullYear(i[r++]),r<i.length&&i[r]&&(s.setMonth(i[r++]-1),r<i.length&&i[r]&&(s.setDate(i[r++]),r<i.length&&i[r]&&(s.setHours(i[r++]),r<i.length&&i[r]&&(s.setMinutes(i[r++]),r<i.length&&i[r]&&(s.setSeconds(i[r++]),r<i.length&&i[r]&&s.setMilliseconds(1e3*i[r++]))))))}this.date=s}return this},this.constructor.prototype.valueOf=function(){return this.date},this}function i(){var t=/P(\d+Y)?(\d+M)?(\d+D)?T?(\d+H)?(\d+M)?(\d+\.?\d{0,2}S)?/;return this.interval=arguments.length>0?arguments[0]:0,this.constructor.prototype.toString=function(){var t="P",e=this.interval,i=function(i,s){e>s&&(t+=Math.floor(e/s)+i,e%=s)};return i("Y",31104e3),i("M",2592e3),i("D",86400),e&&(t+="T",i("H",3600),i("M",60),(e=Math.round(100*e)/100)&&(t+=e+"S")),t},this.constructor.prototype.check=function(e){var i=t.exec(e);return i&&i[0].length==e.length},this.constructor.prototype.parse=function(e){var i=0,s=t.exec(e);if(s&&s[0].length==e.length){for(var n=[12,30,24,60,60,1],r=1,o=s.length-1;o>=1;o--)r*=n[o-1],i+=(s[o]?parseFloat(s[o].substring(0,s[o].length-1)):0)*r;this.interval=i}return this},this.constructor.prototype.valueOf=function(){return this.interval},this.constructor.prototype.add=function(t){return this.interval+=t,this},this.constructor.prototype.subtract=function(t){return this.interval-=t,this},this}var s,n=0,r=0,o={0:"No Error",101:"General Exception",102:"General Initialization Failure",103:"Already Initialized",104:"Content Instance Terminated",111:"General Termination Failure",112:"Termination Before Initialization",113:"Termination After Termination",122:"Retrieve Data Before Initialization",123:"Retrieve Data After Termination",132:"Store Data Before Initialization",133:"Store Data After Termination",142:"Commit Before Initialization",143:"Commit After Termination",201:"General Argument Error",301:"General Get Failure",351:"General Set Failure",391:"General Commit Failure",401:"Undefined Data Model Element",402:"Unimplemented Data Model Element",403:"Data Model Element Value Not Initialized",404:"Data Model Element Is Read Only",405:"Data Model Element Is Write Only",406:"Data Model Element Type Mismatch",407:"Data Model Element Value Out Of Range",408:"Data Model Dependency Not Established"};function a(){this.cmi={_version:{_value:"1.0",_type:"string",_access:5},comments_from_learner:{_count:{_value:0,_type:"integer",_access:5},_children:{_value:"comment,location,timestamp",_type:"string",_access:5},_items:[],_prototype:{comment:{_value:"",_type:"string",_access:3},location:{_value:"",_type:"string",_access:3},timestamp:{_value:"",_type:"time",_access:3}}},comments_from_lms:{_count:{_value:0,_type:"integer",_access:5},_children:{_value:"comment,location,timestamp",_type:"string",_access:5},_items:[],_prototype:{comment:{_value:"",_type:"string",_access:1},location:{_value:"",_type:"string",_access:1},timestamp:{_value:"",_type:"time",_access:1}}},completion_status:{_value:"unknown",_type:"state(completed;incomplete;not attempted;unknown)",_access:7},completion_threshold:{_value:"",_type:"real",_access:1},credit:{_value:"credit",_type:"state(credit;no-credit)",_access:1},entry:{_value:"ab-initio",_type:"state(ab-initio;resume;)",_access:1},exit:{_value:"",_type:"state(time-out;suspend;logout;normal;)",_access:2},interactions:{_count:{_value:0,_type:"integer",_access:5},_children:{_value:"id,type,objectives,timestamp,correct_responses,weighting,learner_response,result,latency,description",_type:"string",_access:5},_items:[],_prototype:{id:{_value:"",_type:"string",_access:3},type:{_value:"",_type:"state(true-false;choice;fill-in;long-fill-in;likert;matching;performance;sequencing;numeric;other)",_access:3},objectives:{_count:{_value:0,_type:"integer",_access:5},_items:[],_prototype:{id:{_value:"",_type:"string",_access:3}}},timestamp:{_value:"",_type:"time",_access:3},correct_responses:{_count:{_value:0,_type:"integer",_access:5},_items:[],_prototype:{pattern:{_value:"",_type:"string",_access:3}}},weighting:{_value:0,_type:"real",_access:3},learner_response:{_value:"",_type:"string",_access:3},result:{_value:"",_type:"state(correct;incorrect;unanticipated;neutral)|real",_access:3},latency:{_value:0,_type:"timeinterval",_access:3},description:{_value:"",_type:"string",_access:3}}},launch_data:{_value:"",_type:"string",_access:1},learner_id:{_value:"urn:VTE:user-generic-id",_type:"string",_access:5},learner_name:{_value:"user_generic_name",_type:"string",_access:5},learner_preference:{_count:{_value:0,_type:"integer",_access:5},_children:{_value:"audio_level,language,delivery_speed,audio_captioning",_type:"string",_access:5},_items:[],_prototype:{audio_level:{_value:1,_type:"real",_access:7},language:{_value:"",_type:"string",_access:7},delivery_speed:{_value:1,_type:"real",_access:7},audio_captioning:{_value:"0",_type:"state(-1;0;1)",_access:7}}},location:{_value:"",_type:"string",_access:3},max_time_allowed:{_value:"",_type:"timeinterval",_access:1},mode:{_value:"normal",_type:"state(browse;normal;review)",_access:5},objectives:{_count:{_value:0,_type:"integer",_access:5},_children:{_value:"id,score,success_status,completion_status,description",_type:"string",_access:5},_items:[],_prototype:{id:{_value:"",_type:"string",_access:3},score:{_children:{_value:"scaled,raw,min,max",_type:"string",_access:5},scaled:{_value:"",_type:"real",_access:3},raw:{_value:"",_type:"real",_access:3},min:{_value:"",_type:"real",_access:3},max:{_value:"",_type:"real",_access:3}},success_status:{_value:"unknown",_type:"state(passed;failed;unknown)",_access:7},completion_status:{_value:"unknown",_type:"state(completed;incomplete;not attempted;unknown)",_access:7},description:{_value:"",_type:"string",_access:3}}},progress_measure:{_value:"",_type:"real",_access:3,_relationship:function(t){return l.cmi.progress_measure._value=t,l.cmi.progress_measure._access|=4,0==t?(l.cmi.completion_status._value="not attempted",l.cmi.completion_status._access|=4):1==t&&(l.cmi.completion_status._value="completed",l.cmi.completion_status._access|=4),4&l.cmi.completion_threshold._access&&(t>=l.cmi.completion_threshold._value?l.cmi.completion_status._value="completed":l.cmi.completion_status._value="incomplete",l.cmi.completion_status._access|=4),"true"}},scaled_passing_score:{_value:"",_type:"real",_access:7},score:{_children:{_value:"scaled,raw,min,max",_type:"string",_access:5},scaled:{_value:"",_type:"real",_access:3,_relationship:function(t){return l.cmi.score.scaled._value=t,l.cmi.score.scaled._access|=4,4&l.cmi.scaled_passing_score._access&&(t>=l.cmi.scaled_passing_score._value?l.cmi.success_status._value="passed":l.cmi.success_status._value="failed",l.cmi.success_status._access|=4),"true"}},raw:{_value:"",_type:"real",_access:3},min:{_value:"",_type:"real",_access:3},max:{_value:"",_type:"real",_access:3}},session_time:{_value:"",_type:"timeinterval",_access:2},success_status:{_value:"unknown",_type:"state(passed;failed;unknown)",_access:7},suspend_data:{_value:"",_type:"string",_access:3},time_limit_action:{_value:"continue,no message",_type:"state(exit,message;continue,message;exit,no message;continue,no message)",_access:5},total_time:{_value:"PT0H0M0S",_type:"timeinterval",_access:5}},this.c3d={hasQuestions:{_value:"unknown",_type:"boolean",_access:3}}}var c=new function(){this.currentID="",this.setData=function(t,e){this[t]=e},this.getData=function(t){var e;return t||(t="_default"),this[t]?e=this[t]:(e=new a,this.setData(t,e)),this.currentID=t,e}},l=new a;this.constructor.prototype.Initialize=function(){switch(s="Initialize()",r=101,n){case 0:r=0,n=1;break;case 1:break;case 2:return r=104,"false"}return"true"},this.constructor.prototype.Terminate=function(){switch(s="Terminate()",r=101,n){case 0:return r=112,"false";case 1:r=0,n=2;break;case 2:return r=113,"false"}return"true"},this.constructor.prototype.Commit=function(){switch(s="Commit()",r=101,n){case 0:return r=142,"false";case 1:r=0;case 2:return r=143,"false"}return"true"},this.constructor.prototype.GetLastError=function(){return r},this.constructor.prototype.GetErrorString=function(t){return o[t]},this.constructor.prototype.GetDiagnostic=function(t){return s},this.constructor.prototype.SetValue=function(o,a){s="SetValue('"+o+"', '"+a+"')";var c=arguments.length>2&&arguments[2];if(!c)switch(n){case 0:return r=132,"false";case 2:return r=133,"false"}r=0;for(var u=o.split("."),p=l;u.length;){o=u.shift();var h=parseInt(o);if(isNaN(h)){if(!(o in p))return r=401,"false";p=p[o]}else{if(!("_items"in p))return r=351,"false";if(p._items.length>h)p=p._items[h];else{if(p._items.length!=h)return r=351,"false";p._items[h]=t(p._prototype),p._count._value=p._items.length,p=p._items[h]}}}if(p instanceof Object&&"_value"in p){if(0!=(8&p._access))return r=402,"false";if(!c&&0==(2&p._access))return r=404,"false";for(var _=p._type.split("|"),m=!1,d=0;d<_.length&&!m;d++){var f=/(\w+)\(?([\w\s-,;]*)\)?/.exec(_[d]);if(f)switch(f[1]){case"state":for(var v=f[2].split(";"),y=0;y<v.length&&!m;y++)m=v[y]==a;break;case"integer":m=""!=a&&!isNaN(parseInt(a));break;case"real":m=""!=a&&!isNaN(parseFloat(a));break;case"timeinterval":m=""!=a&&(new i).check(a);break;case"time":m=""!=a&&(new e).check(a);break;default:m=!0}}return m?"_relationship"in p?p._relationship(a):(p._value=a,p._access|=4,"true"):(r=406,"false")}return r=351,"false"},this.constructor.prototype.GetValue=function(t){switch(s="GetValue('"+t+"')",n){case 0:return r=122,"false";case 2:return r=123,"false"}r=0;for(var e=t.split("."),i=l;e.length;){t=e.shift();var o=parseInt(t);if(isNaN(o)){if(!(t in i))return r=401,"";i=i[t]}else{if(!("_items"in i))return r=301,"";if(!(i._items.length>o))return r=301,"";i=i._items[o]}}return i instanceof Object&&"_value"in i?0!=(8&i._access)?(r=402,""):0==(1&i._access)?(r=405,""):0==(4&i._access)?(r=403,""):i._value:(r=301,"")},this.constructor.prototype.SetValueForItemById=function(o,a,l){switch(s="SetValue('"+o+"', '"+a+"')",n){case 0:return r=132,"false";case 2:return r=133,"false"}r=0;for(var u=o.split("."),p=c.getData(l);u.length;){o=u.shift();var h=parseInt(o);if(isNaN(h)){if(!(o in p))return r=401,"false";p=p[o]}else{if(!("_items"in p))return r=351,"false";if(p._items.length>h)p=p._items[h];else{if(p._items.length!=h)return r=351,"false";p._items[h]=t(p._prototype),p._count._value=p._items.length,p=p._items[h]}}}if(p instanceof Object&&"_value"in p){if(0!=(8&p._access))return r=402,"false";if(0==(2&p._access))return r=404,"false";for(var _=p._type.split("|"),m=!1,d=0;d<_.length&&!m;d++){var f=/(\w+)\(?([\w\s-,;]*)\)?/.exec(_[d]);if(f)switch(f[1]){case"state":for(var v=f[2].split(";"),y=0;y<v.length&&!m;y++)m=v[y]==a;break;case"integer":m=""!=a&&!isNaN(parseInt(a));break;case"real":m=""!=a&&!isNaN(parseFloat(a));break;case"timeinterval":m=""!=a&&(new i).check(a);break;case"time":m=""!=a&&(new e).check(a);break;default:m=!0}}return m?"_relationship"in p?p._relationship(a):(p._value=a,p._access|=4,"true"):(r=406,"false")}return r=351,"false"},this.constructor.prototype.GetValueForItemById=function(t,e){switch(s="GetValue('"+t+"')",n){case 0:return r=122,"false";case 2:return r=123,"false"}r=0;for(var i=t.split("."),o=c.getData(e);i.length;){t=i.shift();var a=parseInt(t);if(isNaN(a)){if(!(t in o))return r=401,"";o=o[t]}else{if(!("_items"in o))return r=301,"";if(!(o._items.length>a))return r=301,"";o=o._items[a]}}return o instanceof Object&&"_value"in o?0!=(8&o._access)?(r=402,""):0==(1&o._access)?(r=405,""):0==(4&o._access)?(r=403,""):o._value:(r=301,"")},this.constructor.prototype.GetNewTimeIntervalObject=function(t){return new i(t)},this.constructor.prototype.GetNewTimeObject=function(){return new e},this.constructor.prototype.startLO=function(t){return l=c.getData(t),!0}};i.exports=s}.call(e,i,e,t))||(t.exports=s)},function(t,e,i){var s;void 0===(s=function(t,e,s){var n,r,o=i(1),a=Cortona3DSolo;function c(t){t?o.initialize(t):o.initialize()}function l(){o.isTerminated()||(a.training.isActive()?(o.set("cmi.session_time","PT"+a.training.getSessionTime()+"S"),o.set("cmi.exit","suspend")):o.set("cmi.exit","logout"),o.terminate())}s.exports={loadPage:c,loadPageExpand:function(){c();var t=o.get("cmi.completion_status");"not attempted"!=t&&"unknow"!=t||o.set("cmi.completion_status","incomplete"),"unknow"==o.get("cmi.success_status")&&o.set("cmi.success_status","unknown"),r=!1,n=(new Date).getTime()},unloadPage:l,unloadPageExpand:function(){1!=r&&(a.training.hasQuestions||(o.set("cmi.completion_status","completed"),o.set("cmi.success_status","passed")),o.set("cmi.exit","suspend"),function(){if(0!=n)var t=function(t){var e,i,s,n,r,o,a,c="";e=Math.floor(t/10),a=Math.floor(e/315576e4),e-=315576e4*a,o=Math.floor(e/26298e4),e-=26298e4*o,r=Math.floor(e/864e4),e-=864e4*r,n=Math.floor(e/36e4),e-=36e4*n,s=Math.floor(e/6e3),e-=6e3*s,i=Math.floor(e/100),a>0&&(c+=a+"Y");o>0&&(c+=o+"M");r>0&&(c+=r+"D");(e-=100*i)+i+s+n>0&&(c+="T",n>0&&(c+=n+"H"),s>0&&(c+=s+"M"),e+i>0&&(c+=i,e>0&&(c+="."+e),c+="S"));""==c&&(c="0S");return c="P"+c}((new Date).getTime()-n);o.set("cmi.session_time",t)}(),r=!0,o.terminate())},scenarioStart:function(){a.training.username=o.get("cmi.learner_name"),a.training.isExam()?(o.set("cmi.completion_status","incomplete"),o.set("cmi.success_status","unknown"),o.set("cmi.score.min","0"),o.set("cmi.score.max","100"),o.set("cmi.score.raw","0"),o.set("cmi.score.scaled","0")):"completed"!==o.get("cmi.completion_status")&&o.set("cmi.completion_status","incomplete")},scenarioFinish:function(){var t,e="PT"+a.training.getSessionTime()+"S",i=a.training.getSuccessStatus(),s=a.training.getScaledScore();o.set("cmi.session_time",e),i&&(o.set("cmi.completion_status","completed"),o.set("cmi.success_status",i)),a.training.isExam()&&(o.set("cmi.score.raw",String(Math.round(100*s))),o.set("cmi.score.scaled",String((t=s,Math.round(100*t)/100))),i&&l())},loadScenario:function(){},stepStarted:function(){},stepFinished:function(){},stepFailed:function(){},setScore:function(t,e,i){o.set("cmi.score.raw",t),o.set("cmi.score.min","0"),o.set("cmi.score.max",e),o.set("cmi.score.scaled",i);var s=o.get("cmi.scaled_passing_score");s||(s=.7),s<=i?(o.set("cmi.success_status","passed"),o.set("cmi.completion_status","completed")):o.set("cmi.success_status","failed")},isStub:function(){return o.isStub()}}}.call(e,i,e,t))||(t.exports=s)}])}));